#ifndef __DC_SNAKE_H
#define __DC_SNAKE_H

#include "DCondition.hxx"
#include "Primitives.hxx"

CODE_MODULE_PROTOTYPE( DcSnake, DcSnake );
using namespace std;

class SnakeWrapper: public CatomWrapper {
	public:
	SnakeWrapper(CatomSim* c) :CatomWrapper(c) {}
	virtual VarCode codeForVarname(string varname);
	virtual float getRealVar(VarCode var);
	virtual void setRealVar(VarCode var, float val);
};


class DcSnake : public DistributedCondition {
public:
	DcSnake(catomID _hostCatom):DistributedCondition(_hostCatom)  {}
	virtual ModuleWrapper *localModule() { return new SnakeWrapper(HOSTCATOMSIM); }
	void simulationStart();
	void newTick();
	void endTick();
	float jointAngle;
	float parent;
	float phase;
	float time;
	WorldPoint3D startPos;
};

#endif
