// Nels Beckman
// FBlockNeighbor.hxx
// March 12th, 2007
//
// This class is just like its parent class, RPCNeighbor. The only
//   difference is that it traps the exception thrown when a send
//   doesn't succeed, and declares a transaction failure.

#include "RPCNeighbor.hxx"

#ifndef __FBLOCKNEIGHBOR_H
#define __FBLOCKNEIGHBOR_H

template<class F> class FailBlock;

template<class T>
class FBlockNeighbor : public RPCNeighbor<T> {

private:
  FBlockNeighbor() {}
  FBlockNeighbor(const FBlockNeighbor<T>&) { RPCNeighbor<T>::f_dest; }
  
public:
  FBlockNeighbor( FailBlock<T>*, featureID );
  
  virtual T* operator->() const;
};

#endif
